/* Edge list to Graph Base             */

/* input: number n of vertices  and number m of edges  */
/*        followed by an edge list ij                  */
/*        vertices labelled 0,1,...,n-1                */


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <limits.h>
#include "mprs.h"

#define TRUE 1
#define FALSE 0

#define MAXN 200

void main()
{
int n;                /* vertices are numbered 0..n  */
int m;                /* number of edges in graph    */
int A[MAXN][MAXN];
int i,j,k,M,first;

  scanf ("%d %d", &n,&m); 
  if(n>200)
    {
      printf("\n No. vertices > %d, increase MAXN and recompile\n",MAXN);
      exit(1);
    }

  for (i=0; i<=n; i++)
     for (j=0; j<=n; j++)
          A[i][j]= -1;  /* we need 0 for first edge */
  for (k=1; k<=m; k++)
    {
     scanf("%d %d",&i,&j);
         A[i][j]=1;
         A[j][i]=1;
    }


  M=0;
  for (i=0;i<n;i++)
   for (j=i+1;j<n;j++)
          if(A[i][j]>0)
            {
             A[i][j]=M++;
             A[j][i]=M++;
            }
             

  fprintf(stderr,"\n Input graph with edge numbers >=0 :");
  for (i=0;i<n;i++)
   {
   fprintf(stderr,"\n%d: ",i);
   for (j=0;j<n;j++)
       {
          fprintf(stderr," %d",A[i][j]);
       }
   }

  printf("* GraphBase graph (util_types ZZZZZZZZZZZZZZ,%dV,%dA)",n,2*m);
  printf("\n\"Hello World\",%d,%d",n,2*m);
  printf("\n* Vertices");
  for (i=0; i<n; i++)  /* print first edge for each vertex */
    {
     j=0;
     while (j<n && A[i][j]== -1) j++;
     if (j<n)
         printf("\n\"%d\",A%d",i,A[i][j]); 
     else
         printf("\n%d,0",i); /*no edge adjacent to i */ 
    }
  M=0;
  printf("\n* Arcs");
  for (i=0; i<n; i++)  /* print Vtarget,Anext,M,0  */
     {
      j=i+1; 
      while (j<n)
        {
         if(A[i][j] >= 0 )
           {
            k=j+1;   /* find next edge if any */
            while (k<n && A[i][k]== -1)  k++;
            if (k<n)
               printf("\nV%d,A%d,%d",j,A[i][k],M++);
            else
               printf("\nV%d,0,%d",j,M++);
            /* do the mirror image edge */
            k=i+1;   /* find next edge if any */
            while (k<n && A[j][k]== -1)  k++;
            if (k<n)
               printf("\nV%d,A%d,%d",i,A[j][k],M++);
            else
               printf("\nV%d,0,%d",i,M++);
           }
         j++;
        }
     }
  printf("\n* Checksum -404\n");
  fprintf(stderr,"\n");
}   
